(function() {
    var getMarkColor = function(mark) {

        mark = mark.replace(",",".")
        if(mark.toLowerCase() == "me")
            return "70a62c";
        if(mark.toLowerCase() == "oe")
            return "a90000";
        if(mark == "?" || isNaN(mark)) 
            return "000000";

        mark = parseFloat(mark,10);
        if(mark < 2.5)
            return "70a62c";
        if(mark < 4.5)
            return "bba300";
        else
            return "a90000";
            
    }
    
    var parseRow = function(data,start) {
        var lecture = data[start];
        var type = data[start+1];
        var mark = data[start+2];
        if(lecture.length > 20)
            lecture = lecture.substr(0,20)+"…";

        return "<span style='align:left;font-weight:bold'>"+lecture+"</span>("+type+
            ")<div style='float:right;color:#"+getMarkColor(mark)+"'>"+mark+"</div>";
    };
    
    window.ListPopulator = {
        _rowData: [],
        
        update: function(data) {
            ListPopulator._rowData = data;
            document.getElementById('list').object.reloadData();
            
        },
        
        // Die Liste ruft diese Methode auf, um zu ermitteln, wie viele Zeilen für die Liste benötigt werden.
        numberOfRows: function() {
            return this._rowData.length/3;
        },
        
        // Die Liste ruft diese Methode für jede Zeile einmal auf.
        prepareRow: function(rowElement, rowIndex, templateElements) {

            if (templateElements.lecture) {
                templateElements.lecture.innerHTML = parseRow(ListPopulator._rowData,rowIndex*3);
            }

            // Weisen Sie einen Klick-Event-Handler für die Zeile zu.
            rowElement.onclick = function(event) {
                
            };
        }
    }
})()