var HTTPFetcher = function(ConfigManager) {
    this.config             = null;
    this.lastCookies        = "";
    this.sessionTimeout     = 60; // session timeout in seconds -> TODO: outsource to prefs file
    this.loggedIn           = false;
    
    var _this = this; //closure wide reference to object identfier
    // TODO: Outsource to prefs file
    
    var updateStatusText = function(msg) {
        document.getElementById('txtStatus').innerHTML = msg;
    }
    
    var URI = {
        login: 'pls/papi/papiadmin.do_login1',
        setSession: 'pls/papi/papiadmin.setLoginTime',
        requestNewMarks: 'pls/exammarks/student.show_noten',
        requestAllMarks: 'studycertificate-web/transcript.iface'
    }
    
    // url parameters that should be resend
    var PersistedURIParams = {
    }
    
    var LoginParams = {
        'name' : 'BenName',
        'pass' : 'Password'
    }

    this.login = function() {

        var XHR = new XMLHttpRequest();
        XHR.lastURI = this.config.address+"/"+URI.login;
        XHR.open("POST", this.config.address+"/"+URI.login);
        updateStatusText("Login...");
        XHR.onload = function() {
            // Virtuohm always returns 200, so this is just in case they change their system
            // to be http-compliant…
            if(_this.validateResponse.call(_this,XHR) === true) {
                updateStatusText("Login successful.");
                _this.getQueryParams.call(_this,XHR);
                updateStatusText("Creating session…");
                _this.finishLogin.call(_this);
//                _this.updateStatus.call(_this);
            }
        }
        XHR.setRequestHeader("Cache-Control", "no-cache");

        var data = "";
        var glue = false;
        for(var i in LoginParams) {
            data += (glue ? "&" : "")+LoginParams[i]+"="+encodeURIComponent(this.config[i]);
            glue = true;
        }
        XHR.send(data);
    }
    
    this.validateResponse = function(XHR) {

        switch(XHR.status) {
            case 200:
            case 201:
                break;
            case 404:
                this.onError("The page "+XHR.lastURI+" could not be found");
                return false;
            case 403:
            case 401:
                this.onError("invalid_credentials");
                return false;
            case 500:
                this.onError("internal_error");
                return false;
            default:
                this.onError("unknown_error");
        }
        var state = (new ResponseValidator(XHR.responseText)).getCurrentState();
        switch(state) {
            case 'login_error':
                this.loggedIn = false;
                //alert(XHR.responseText);
                this.onError("invalid_credentials");
                return false;
            case 'session_timeout':
            case 'login_page':
                this.loggedIn = false;
                this.onError("session_timeout");
                return false;
            case 'login_success':
            case 'pending_marks':
            case 'main_page':
            case 'all_marks':
                return true;
                break;
            default:
                this.onError("unknown_error");
                return false;
        }

    }
    

    this.getQueryParams = function(LastResponse) {
        this.lastCookies = LastResponse.getResponseHeader("Set-Cookie");
        console.log("Cookies : "+this.lastCookies);
        this.persistedURIParams = (new ResponseValidator(LastResponse.responseText)).getCredentialParameters();
        console.log("Params : "+this.persistedURIParams);
    }
    
    this.getRequestURI = function(name) {
        var url = this.config.address+"/"+URI[name]+"?";
        var glue = false
        for(var i in this.persistedURIParams) {
            if(!this.persistedURIParams[i])
                continue;
            url += (glue ? "&" : "") + i+"="+this.persistedURIParams[i];
            glue = true;
        }
        return url;    
    }
    
    this.finishLogin = function() {
        var XHR = new XMLHttpRequest();
        XHR.open("GET", this.getRequestURI("setSession"));
        XHR.lastURI = this.getRequestURI("setSession");
        XHR.onload = function() {
            // Virtuohm always returns 200, so this is just in case they change their system
            // to be http-compliant…
            if(_this.validateResponse.call(_this,XHR) === true) {
                updateStatusText("Session created…");
                _this.persistedURIParams["in_userid"] = null;
                _this.loggedIn = true;
                _this.updateStatus.call(_this);
            }
        }
        XHR.setRequestHeader("Cache-Control", "no-cache");
        XHR.setRequestHeader("Cookie", this.lastCookies);
        XHR.send(null);
    }
    
    this.updateStatus = function() {
        if(this.loggedIn == false)
            return this.login();
        var XHR = new XMLHttpRequest();
        XHR.open("GET", this.getRequestURI("requestNewMarks"));
        XHR.lastURI = this.getRequestURI("requestNewMarks");
        updateStatusText("Updating");
        XHR.onload = function() {
            // Virtuohm always returns 200, so this is just in case they change their system
            // to be http-compliant…
            if(_this.validateResponse.call(_this,XHR) === true) {
                data = VirtuOhmParser.getDataFromCurrentMarks(XHR.responseText);
                _this.onDataUpdate(data);
                updateStatusText((new Date()).toGMTString());
            }
        }
        XHR.setRequestHeader("Cache-Control", "no-cache");
        XHR.setRequestHeader("Cookie", this.lastCookies);
        XHR.send(null);

    }
    
    this.onDataUpdate = function(data) {};
    this.onError = function(msg) {};
    
    var constructor = function(ConfigManager) {
        this.config = ConfigManager;
        this.setupRequestObject();
    }
    
    this.onLoadHandler = function() {
        alert(this.XHR.responseText);
    }
    
    this.setupRequestObject = function() {
    }
    
    constructor.apply(this,arguments);
}